/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is NewsFox.
 *
 * The Initial Developer of the Original Code is
 * Andy Frank <andy@andyfrank.com>.
 * Portions created by the Initial Developer are Copyright (C) 2005-2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Andrey Gromyko <andrey@gromyko.name>
 *   Ron Pruitt <wa84it@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var scKeyList = new Array();

////////////////////////////////////////////////////////////////
// Text view
////////////////////////////////////////////////////////////////

function getTextView(art)
{
	if (gOptions.copyToClip)
	{
		var trans = Components.classes["@mozilla.org/widget/transferable;1"]
			.createInstance(Components.interfaces.nsITransferable);
  	trans.addDataFlavor("text/html");
	  trans.addDataFlavor("text/unicode");

		var htmlStr = Components.classes["@mozilla.org/supports-string;1"]
			.createInstance(Components.interfaces.nsISupportsString);
 		htmlStr.data = art.body;

		trans.setTransferData("text/html",htmlStr, htmlStr.toString().length);
    trans.setTransferData("text/unicode",htmlStr, htmlStr.toString().length);

		var clipId = Components.interfaces.nsIClipboard;
		var clipB = Components.classes["@mozilla.org/widget/clipboard;1"]
			.getService(clipId);
  	clipB.setData(trans,null,clipId.kGlobalClipboard);
	}

	var iframe = document.getElementById("buildContent");
	var doc = iframe.contentDocument;
	iframe.docShell.allowJavascript = false;

	while (doc.body.childNodes.length > 0) doc.body.removeChild(doc.body.childNodes[0]);

  var div = doc.createElement("div");
	div.setAttribute("id","newsfox-box");
		var s = doc.createElement("span");
		s.setAttribute("class","newsfox-mail");
		var a = doc.createElement("a");
		a.setAttribute("href",makeMailto(art.title,art.link));
			var img = doc.createElement("img");
			img.setAttribute("src","chrome://newsfox/skin/images/mail.png");
			img.setAttribute("style","border: 0px; padding-right: 7px;");
		a.appendChild(img);
		s.appendChild(a);
	div.appendChild(s);
		var b = getXhtmlBody(art.title,"b",doc);
		b.setAttribute("class","newsfox-title");
		b.appendChild(doc.createElement("br"));
	div.appendChild(b);
		var s = doc.createElement("span");
		s.setAttribute("class","newsfox-tag");
		s.setAttribute("style","font-size: smaller");
		s.innerHTML = "";
		if (art.tag != "") s.innerHTML += "&lt;" + emphsrch(art.tag) + "&gt; ";
	div.appendChild(s);
		var p = doc.createElement("span");
		p.setAttribute("class","newsfox-category");
		p.setAttribute("style","font-size: smaller");
		p.innerHTML = "";
  	if (art.category != "") p.innerHTML += "[" + emphsrch(art.category) + "] ";
	div.appendChild(p);
		var p2 = doc.createElement("span");
		p2.setAttribute("class","newsfox-date");
		p2.setAttribute("style","font-size: smaller");
		p2.innerHTML = displayDate(art.date, LONG_DATE_STYLE) + "<br/>";
	div.appendChild(p2);
	if (art.link)
	{
  	var a = doc.createElement("a");
		a.setAttribute("href", art.link);
		if (!gOptions.openInViewPane) a.setAttribute("target", "_blank");
		a.setAttribute("class","newsfox-link");
		a.innerHTML = art.link + "<br/>";
		div.appendChild(a);
	}

	if (art.enclosures.length > 0)
	{
		var s = doc.createElement("span");
		s.setAttribute("class","newsfox-enclosures");
		for (var i=0; i<art.enclosures.length; i++)
		{
			var artenc = art.enclosures[i];
			var nobr = doc.createElement("span");  // xhtml equivalent of <nobr>
			nobr.setAttribute("style","white-space: nowrap;");
			var a = doc.createElement("a");
			a.setAttribute("class","newsfox-encl");
			a.setAttribute("href", artenc.url);
			a.setAttribute("target","_blank");
			var img = doc.createElement("img");
			var imgsrc;
			var encltype = artenc.type.substring(0,5);
			if (encltype == "video")
				imgsrc = "chrome://newsfox/skin/images/encl-video.png";
			else if (encltype == "audio")
				imgsrc = "chrome://newsfox/skin/images/encl-audio.png";
			else
				imgsrc = "chrome://newsfox/skin/images/encl-other.png";
			img.setAttribute("src",imgsrc);
			img.setAttribute("style","border: 0px; padding-right: 2px;");
			var p = doc.createElement("span");
			p.innerHTML = artenc.type;
			a.appendChild(img);
			a.appendChild(p);
			nobr.appendChild(a);
			var p = doc.createElement("span");
			var sz = Math.round(artenc.length/1024);
			if (sz == 0 || isNaN(sz)) sz = "----";
			sz += "Kb";
			p.innerHTML = ": " + sz + "&nbsp;&nbsp;&nbsp;&nbsp;";
			nobr.appendChild(p);
			s.appendChild(nobr);
		}
		s.appendChild(doc.createElement("br"));
		div.appendChild(s);
	}

	var p = getXhtmlBody(art.body,"p",doc);

	doc.body.appendChild(div);
	doc.body.appendChild(p);
}

function makeMailto(title,link)
{
	var uri = encodeURI("mailto:?subject=" + entityDecode(title) + "&body=" + link);
	uri = uri.replace(/\?/g,"%3F");
	uri = uri.replace(/=/g,"%3D");
	uri = uri.replace(/&/g,"%26");
	uri = uri.replace("%3Fsubject%3D","?subject=");
	uri = uri.replace("%26body%3D","&body=");
	return(uri);
}

function getXhtmlBody(body,tag,doc)
{
	if (body.substring(0,7) == "<xhtml>")
	{
  	var p = doc.createElementNS(XHTML,tag);
		var body2 = body.replace(/^<xhtml>|<\/xhtml>$/g,"");
		var xmlBody = new DOMParser().parseFromString(emphsrch(body2),"text/xml");
		// Atom specification guarantees a single <div> element, now a <span>
		var xBody = doc.importNode(xmlBody.childNodes[0],true);
		p.appendChild(xBody);
	}
	else
	{
		var p = doc.createElement(tag);
		p.innerHTML = emphsrch(body);
	}
	return p;
}

function emphsrch(html)
{
	if (gCollect.type == 3)  // search
	{
		var st = gCollect.getSrchText();
		for (var i=0; i<st.length; i++)
			html = hilite(st[i],html);
	}
	return html;
}

function hilite(srchtext, html)
{
	var srchdat = gFdGroup[gCollect.grpindex].srchdat;
	var textflags = srchdat.textflags;
	if (srchtext.length > 0)
	{
		var caseSen = ((textflags & 0x04) == 0);
		var text = html;
		var repltext = srchtext;
		if (!caseSen)
		{
			text = text.toLowerCase();
			repltext = repltext.toLowerCase();
		}
		var todo = new Array();
		var startpos = 0;
		var newpos = text.indexOf(repltext,startpos);
		while (newpos > -1)
		{
			// check if in <tag> or in html
			if (text.lastIndexOf(">",newpos) >= text.lastIndexOf("<",newpos))
				todo.push(newpos);
			startpos = newpos + 1;
			newpos = text.indexOf(repltext,startpos);
		}
		var pos;
		var len = srchtext.length;
		for (var i=todo.length-1; i>=0; i--)
		{
			pos = todo[i];
			html = html.substring(0,pos)+"<span class='srch'>"+html.substring(pos,pos+len)+"</span>"+html.substring(pos+len);
		}
	}
	return html;
}

function resetIframe(id)
{
	var iframe = document.getElementById(id);
	var doc = iframe.contentDocument;

// doesn't work, need to keep node with name='html' if it exists
//	while (doc.childNodes.length > 0) doc.removeChild(doc.childNodes[0]);

	var docHEAD = null;
	for (var i=0; i<doc.childNodes.length; i++)
		if (doc.childNodes[i].localName == "HTML")
		{
			var docHTML = doc.childNodes[i];
			for (i=0; i<docHTML.childNodes.length; i++)
				if (docHTML.childNodes[i].localName == "HEAD")
				{
					docHEAD = docHTML.childNodes[i];
					while (docHEAD.childNodes.length > 0)
						docHEAD.removeChild(docHEAD.childNodes[0]);
				}
				else if (docHTML.childNodes[i].localName == "BODY")
				{
					var docBODY = docHTML.childNodes[i];
					while (docBODY.childNodes.length > 0)
						docBODY.removeChild(docBODY.childNodes[0]);
				}
				else
					docHTML.removeChild(docHTML.childNodes[i]);
		}

	var meta = doc.createElement("meta");
	meta.setAttribute("http-equiv", "content-type");
	meta.setAttribute("content", "text/html");
	meta.setAttribute("charset", "utf-8");

	var sty = doc.createElement("style");
	sty.setAttribute("type","text/css");
	sty.innerHTML = getCss();

	docHEAD.appendChild(meta);
	docHEAD.appendChild(sty);
}

////////////////////////////////////////////////////////////////
// CSS file
////////////////////////////////////////////////////////////////

function getCss()
{
	var file = getProfileDir();
	file.append("textview.css");
	return fileRead(file);
}

function fileRead(file)
{
  var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance( Components.interfaces.nsIFileInputStream );
  inputStream.init( file,0x01,00004,null);
  var scInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance( Components.interfaces.nsIScriptableInputStream );
  scInputStream.init(inputStream);
  var output = scInputStream.read(-1);
  scInputStream.close();
  inputStream.close();
	return output;
}

function makeCss()
{
	var file, out;
	file = getProfileDir();
	file.append("textview.css");
	if (!file.exists())
	{
		out = openOutputStream(file, 0x02 | 0x08 | 0x20);
		println(out, "body { font:10pt Verdana,sans-serif; background:white; }\n");
		println(out, "#newsfox-box { background: #e3dfd9; padding:10px; overflow:hidden; }\n");
		println(out, ".srch { color: red; font-weight: bold; }\n");
		out.close();
	}
	else
	{
		var cssTxt = getCss();
		var saveIt = false;
		if (cssTxt.indexOf(".srch") == -1)
		{
			cssTxt += "\n.srch { color: red; font-weight: bold; }\n";
			saveIt = true;
		}
		if (saveIt)
		{
			file.remove(false);
			out = openOutputStream(file, 0x02 | 0x08 | 0x20);
			println(out, cssTxt);
			out.close();
		}
	}
}

////////////////////////////////////////////////////////////////
// Keyboard shortcuts
////////////////////////////////////////////////////////////////

function updateShortcuts(index)
{
	var keySet = document.getElementById("shortcut-keys");
	while (keySet.firstChild != null) keySet.removeChild(keySet.firstChild);

	for (var i=0; i<scKeyList.length; i++)
	{
		var idkey = scKeyList[i];
		idkey.setAttribute("modifiers", idkey.getAttribute("mod"+index));
		idkey.setAttribute("key", idkey.getAttribute("key"+index));
		if (index != 0) keySet.appendChild(idkey);
	}

	var feedTree = document.getElementById("newsfox.feedTree");
	if (index != 0)
		feedTree.setAttribute("disableKeyNavigation", true);
	else
		feedTree.removeAttribute("disableKeyNavigation");

	makeAccel();
}

function makeAccel()
{
	var file, out;
	file = getProfileDir();
	file.append("accel.xml");
	if (file.exists()) file.remove(false);

	out = openOutputStream(file, 0x02 | 0x08 | 0x20);
	println(out, "<?xml version=\"1.0\"?>\n<body>\n");
	const NF_SB = document.getElementById("newsfox-string-bundle");
  var feedKeyNav = NF_SB.getString('feedKeyNav');
	println(out, "\t<info val=\"" + feedKeyNav + "\" />");
	var feedTree = document.getElementById("newsfox.feedTree");
	var dKNvalue = "true";
	if (feedTree.getAttribute("disableKeyNavigation") != "true") dKNvalue = "false";
	println(out, "\t<feedtree disableKeyNavigation=\"" + dKNvalue + "\"/>\n");

	var keySet = document.getElementById("shortcut-keys");
	for (var i=keySet.firstChild; i != null; i=i.nextSibling)
	{
		println(out, "\t<key id=\"" + i.id + "\" modifiers=\"" + i.getAttribute("modifiers") + "\" key=\"" + i.getAttribute("key") + "\"/>");
	}
	println(out, "</body>");
	out.close();
}

function getAccel()
{
	var file = getProfileDir();
	file.append("accel.xml");

	if (!file.exists())
		makeAccel();
	else
	{
    var xml = document.implementation.createDocument("","",null);
    xml.async = false;
    xml.load("file:///" + file.path);

		var keyNav = xml.getElementsByTagName("feedtree");
		if (keyNav.length != 0)
		{
			var feedTree = document.getElementById("newsfox.feedTree");
			if (keyNav[0].getAttribute("disableKeyNavigation") != "false")
				feedTree.setAttribute("disableKeyNavigation", true);
			else
				feedTree.removeAttribute("disableKeyNavigation");
		}

    var kids = xml.getElementsByTagName("key");
    for (var i=0; i<kids.length; i++)
    {
			var idkey = document.getElementById(kids[i].getAttribute("id"));
			idkey.setAttribute("modifiers", kids[i].getAttribute("modifiers"));
			idkey.setAttribute("key", kids[i].getAttribute("key"));
		}
	}
	
	var keySet = document.getElementById("shortcut-keys");
	var idkey = keySet.firstChild;
	while (idkey != null)
	{
		scKeyList.push(idkey);
		var mods = idkey.getAttribute("modifiers");
		var keys = idkey.getAttribute("key");
		var tmp = idkey.nextSibling;
		if (mods=="" && keys=="") keySet.removeChild(idkey);
		idkey = tmp;
	}
}

////////////////////////////////////////////////////////////////
// File Util
////////////////////////////////////////////////////////////////

function openOutputStream(file, flags)
{
  var out = Components.classes["@mozilla.org/network/file-output-stream;1"]
    .createInstance(Components.interfaces.nsIFileOutputStream);
  out.init(file, flags, 0664, 0);
  return out;
}

function print(out, data)
{
  out.write(data, data.length);
}

function println(out, data)
{
  data += "\n";
  out.write(data, data.length);
}

////////////////////////////////////////////////////////////////
// Create new feed
////////////////////////////////////////////////////////////////

function createNewFeed(model, url, isExcluded, rmArtfile)
{
	var feed;
  try
  {
    var uid  = model.makeUniqueUid(url); //makeUid(model, url);
    feed = new Feed();
    feed.uid = uid;
    feed.url = url;
    feed.defaultName = uid;
    feed.exclude = isExcluded;
    model.add(feed, isExcluded);
		if (rmArtfile) deleteFeedFromDisk(feed);
    if (!isExcluded)
      {
        var feedtree = document.getElementById("newsfox.feedTree");
        if (gFdGroup[0].expanded == true) feedtree.view.toggleOpenState(0);
        var index = model.size();
        gFdGroup[0].list.push(index-1);
        feedtree.view.toggleOpenState(0);
      }
  }
  catch (err) 
  { 
    var msg = "createNewFeed(): [" + uid + "] " + err
    alert(msg); 
  }
  return feed; 
}

////////////////////////////////////////////////////////////////
// Load feeds from disk
////////////////////////////////////////////////////////////////

function loadIndices()
{
  try
  {
    var file = getProfileDir();
    file.append(MASTER_INDEX+".xml");

    var xml = document.implementation.createDocument("","",null);
    xml.async = false;
    xml.load("file:///" + file.path);

    // Get file version
    var root = xml.getElementsByTagName("newsfox-index")[0];
    var version = root.getAttribute("version");

    var fdgpidxstr = xml.getElementsByTagName("fdgpidx")[0].childNodes[0].nodeValue;
    var tmp = fdgpidxstr.split(",");
    for (var i=0; i < tmp.length; i++)
      tmp[i] = parseInt(tmp[i]);
    gIdx.fdgp = tmp;

    var feedidxstr = xml.getElementsByTagName("feedidx")[0].childNodes[0].nodeValue;
    tmp = feedidxstr.split(",");
    for (i=0; i < tmp.length; i++)
      tmp[i] = parseInt(tmp[i]);
    gIdx.feed = tmp;

    var catgidxstr = xml.getElementsByTagName("catgidx")[0].childNodes[0].nodeValue;
    tmp = catgidxstr.split(",");
    for (i=0; i < tmp.length; i++)
    {
      tmp[i] = parseInt(tmp[i]);
      if (tmp[i] > 0) 
      {
				var feed = gFmodel.get(gIdx.feed[i]);
				loadFeed(feed,true);
      }
    }
    gIdx.catg = tmp;

    var openidxstr = xml.getElementsByTagName("openidx")[0].childNodes[0].nodeValue;
    tmp = openidxstr.split(",");
    for (i=0; i < tmp.length; i++)
      tmp[i] = (tmp[i] == 1);
    gIdx.open = tmp;

		gLoadFlags &= 0xFE;
  }
  catch (err) { gLoadFlags |= 0x01; }
}

function loadGroupModel()
{
  try
  {
    var file = getProfileDir();
    file.append(MASTER_GROUP+".xml");

    var xml = document.implementation.createDocument("","",null);
    xml.async = false;
    xml.load("file:///" + file.path);

    // Get file version
    var root = xml.getElementsByTagName("newsfox-grouplist")[0];
    var version = root.getAttribute("version");

    var tmp = new Array();
    var kids = xml.getElementsByTagName("group");
    for (var i=0; i<kids.length; i++)
    {
			var grp = new FeedGroup();
      gFdGroup[i] = new FeedGroup();
      gFdGroup[i].title = getVal(kids[i], "title", "str", grp.title);
      gFdGroup[i].expanded = getVal(kids[i], "expanded", "bool", grp.expanded);
      var v = child(kids[i], "list");
      if (v != null && v.childNodes.length > 0)
      {
				var tmpstr = v.childNodes[0].nodeValue;
				var tmp = tmpstr.split(",");
				for (var j=0; j < tmp.length; j++)
					gFdGroup[i].list[j] = parseInt(tmp[j]);
      }
			gFdGroup[i].search = getVal(kids[i], "search", "bool", grp.search);
			if (gFdGroup[i].search)
			{
				gFdGroup[i].searchTag = getVal(kids[i], "searchTag", "str", grp.searchTag);
				if (!gFdGroup[i].searchTag)
				{
					gFdGroup[i].showUnread = getVal(kids[i], "showUnread", "bool", grp.showUnread);
					gFdGroup[i].srchdat.flagged = getVal(kids[i], "flagged", "int", grp.srchdat.flagged);
					gFdGroup[i].srchdat.unread = getVal(kids[i], "unread", "int", grp.srchdat.unread);
					gFdGroup[i].srchdat.text = getVal(kids[i], "text", "str", grp.srchdat.text);
					gFdGroup[i].srchdat.textflags = getVal(kids[i], "textflags", "int", grp.srchdat.textflags);
					gFdGroup[i].srchdat.startTime = getVal(kids[i], "startTime", "int", grp.srchdat.startTime);
					gFdGroup[i].srchdat.endTime = getVal(kids[i], "endTime", "int", grp.srchdat.endTime);
				}
			}

			// Version 1.1-2 search used 0-1-2 for body-title-both, 1.3 uses 1-2-3
			if (version == 1.1 || version == 1.2)
				if (gFdGroup[i].search) gFdGroup[i].srchdat.textflags += 1;

			// Version 1.1 encoded strings, version 1.2 uses UTF-8 encoding
			if (version == 1.1)
			{
				gFdGroup[i].title = entityDecode(gFdGroup[i].title);
				if (gFdGroup[i].search)
					gFdGroup[i].srchdat.text = entityDecode(gFdGroup[i].srchdat.text);
			}

    }
    gFdGroup.length = kids.length;

		gLoadFlags &= 0xFD;
  }
  catch (err) { gLoadFlags |= 0x02; }
}

function loadFeedModel()
{
  gFmodel = new FdModel();
  try
  {
    var file = getProfileDir();
    file.append(MASTER+".xml");

    var xml = document.implementation.createDocument("","",null);
    xml.async = false;
    xml.load("file:///" + file.path);

    // Get file version
    var root = xml.getElementsByTagName("newsfox-feedlist")[0];
    var version = root.getAttribute("version");

		var tag = xml.getElementsByTagName("tag");
		if (tag.length) gTag = tag[0].childNodes[0].nodeValue;

		var iconfile, leafName;
    var kids = xml.getElementsByTagName("feed");
    for (var i=0; i<kids.length; i++)
    {
      var feed = new Feed();
			feed.exclude = (kids[i].getAttribute("exclude") == "true");
			feed.uid = getVal(kids[i], "uid", "str", feed.uid);
			feed.defaultName = getVal(kids[i], "dname", "str", feed.uid);
			feed.style = getVal(kids[i], "style", "int", feed.style);
			feed.prvate = getVal(kids[i], "private", "bool", feed.prvate);

      var elem = child(kids[i], "flags");
      if (elem != null && elem.childNodes.length > 0)
      {
        var flags = elem.childNodes[0].nodeValue;
        for (var j=0; j<flags.length; j++)
          feed.flags.push(parseInt(flags.charAt(j)));
      }

			feed.storage = getVal(kids[i], "storage", "bool", feed.storage);
			if (!feed.storage)
			{
				feed.url = getVal(kids[i],"url","str", feed.url);
				feed.homepage = getVal(kids[i],"home","str", feed.homepage);
				feed.deleteOld = getVal(kids[i], "deleteOld", "bool", feed.deleteOld);
				feed.daysToKeep = getVal(kids[i],"daysToKeep","int", feed.daysToKeep);
				var date = getVal(kids[i], "lastUpdate", "str", null);
				if (date)
				{
					feed.lastUpdate = new Date();
 					feed.lastUpdate.setTime(Date.parse(date));
				}
				feed.autoRefreshInterval = getVal(kids[i], "autoRefreshInterval", "int", feed.autoRefreshInterval);
				if (feed.autoRefreshInterval != 0 && feed.autoRefreshInterval < MINFEEDTIME) feed.autoRefreshInterval = MINFEEDTIME;
				feed.autoCheck = getVal(kids[i], "autoCheck", "bool", feed.autoCheck);
				feed.customName = getVal(kids[i],"customName","str", feed.customName);
				feed.dontDeleteUnread = getVal(kids[i], "dontDeleteUnread", "bool", feed.dontDeleteUnread);
	
				iconfile = getProfileDir();
				leafName = feed.uid + ".ico";
				iconfile.append(leafName);
				if (!gOptions.favicons  || !iconfile.exists() || !isImg(iconfile))
					feed.icon.src = ICON_OK;
				else
					feed.icon.src = "file:///" + iconfile.path;
			}
			else  // storage
				feed.icon.src = ICON_STORAGE;

			// Version 1.1-2 encoded strings, version 1.3 uses UTF-8 encoding
			if (version == 1.1 || version == 1.2)
			{
				feed.defaultName = entityDecode(feed.defaultName);
				feed.customName =	entityDecode(feed.customName);
			}

      // Version 1.0 tried to encode body text. Version 1.1
      // just uses CDATA, so decode not necessary
      if (version == 1.0)
      {
        feed.url = decodeHTML(feed.url);
        feed.defaultName = decodeHTML(feed.defaultName);
        feed.homepage = decodeHTML(feed.homepage);
      }

      gFmodel.add(feed);
    }

		gLoadFlags &= 0xFB;
  }
  catch (err) { gLoadFlags |= 0x04; }
}

function loadFeed(feed, force)
{
		doneYet = function()
		{
			if (feed.loaded) return;
			setTimeout(this.doneYet,25);
		}

	if (feed.loaded || (feed.prvate && !force)) return;
	if (feed.loading)
	{
		setTimeout(this.doneYet,25);
		return;
	}
	feed.loading = true;

  try
  {
    var file = getProfileDir();
    file.append(feed.uid + ".xml");
    checkFeedFile(file);

		var xml = "";
		if (feed.prvate)
		{
			var output = fileRead(file);
			var obj = Components.classes["@mozilla.org/io/string-input-stream;1"]
				.createInstance(Components.interfaces.nsIStringInputStream);
			try
			{ var xmlFile = gSdr.decryptString(output); }
			catch(e)
			{
				const NF_SB = document.getElementById("newsfox-string-bundle");
				throw(NF_SB.getString('badPassword'));
			}
			obj.setData(xmlFile,-1);
			xml = new DOMParser().parseFromStream(obj, "UTF-8", -1, "application/xml");
		}
		else
		{
    	xml = document.implementation.createDocument("","",null);
    	xml.async = false;
    	xml.load("file:///" + file.path);
		}

    // Get file version
    var root = xml.getElementsByTagName("newsfox-feed")[0];
    var version = root.getAttribute("version");
		feed.removeAll();

		var un = xml.getElementsByTagName("username");
		if (un.length) feed.username = un[0].childNodes[0].nodeValue;
		var pw = xml.getElementsByTagName("password");
		if (pw.length) feed.password = pw[0].childNodes[0].nodeValue;

		var flags = feed.flags;
		feed.flags = new Array();
    var kids = xml.getElementsByTagName("article");
    for (var i=0; i<kids.length; i++)
    {
			var id = child(kids[i], "id");
			// versions up until 1.2 used link as id
			if (id || version <= 1.2)
			{
				var art = new Article();
				art.link  = getVal(kids[i], "link", "str", art.link);
				art.title  = getVal(kids[i], "title", "str", art.title);
				art.body  = getVal(kids[i], "body", "str", art.body);
				art.category  = getVal(kids[i], "category", "str", art.category);
				art.tag  = getVal(kids[i], "tag", "str", art.tag);
				var date = getVal(kids[i], "date", "str", null);
				art.date  = new Date();
				if (date) art.date.setTime(Date.parse(date));
				art.id = (id) ? id.childNodes[0].nodeValue : art.id;
				var enc = kids[i].getElementsByTagName("enclosure");
				for (var j=0; j<enc.length; j++)
					art.enclosures.push(newEncl(enc[j],"url"));
				art.source.url  = getVal(kids[i], "Surl", "str", art.source.url);
				art.source.name  = getVal(kids[i], "Sname", "str", art.source.name);
	
				// Version 1.1-2 encoded strings, version 1.3 uses UTF-8 encoding
				if (version == 1.1 || version == 1.2)
				{
	      	art.category = entityDecode(art.category);
					art.id = (art.id) ? art.id : art.link;
				}
	
	      // Version 1.0 tried to encode body text. Version 1.1
	      // just uses CDATA, so decode not necessary
	      if (version == 1.0)
	      {
	        art.link  = decodeHTML(art.link);
	        art.title = decodeHTML(art.title);
	        art.body  = decodeHTML(art.body);
	      }
	
	      // Add feed
	      feed.add(art,flags[i]);
			}
    }
    feed.sortCategories();

		// load deleted articles
		if (!feed.storage)
		{
	    var kids = xml.getElementsByTagName("deletedarticle");
	    for (var i=0; i<kids.length; i++)
	    {
	      var art = new Article();
				art.link  = getVal(kids[i], "link", "str", art.link);
				var date = getVal(kids[i], "date", "str", null);
				art.date  = new Date();
				if (date) art.date.setTime(Date.parse(date));
				art.id = getVal(kids[i], "id", "str", art.link);
	
	      feed.deletedAdd(art);
	    }
		}

		// some articles deleted
		if (flags.length != feed.flags.length) saveFeed(feed);
		feed.loaded = true;
  }
  catch (err) { alert("loadFeed(): " + feed.uid + "\n\n" + err); }
	feed.loading = false;
}

function getVal(root,name,type,dfault)
{
	var v = child(root, name);
	if (v == null || v.childNodes.length == 0) return dfault;
	switch (type)
	{
		case "str":
			v = v.childNodes[0].nodeValue;
			break;
		case "int":
			v = parseInt(v.childNodes[0].nodeValue);
			break;
		case "bool":
			v = (v.childNodes[0].nodeValue == "true");
	}
	return v;
}

function checkFeedFile(file)
{
  try
  {
    if (!file.exists())
    {
      var out = openOutputStream(file, 0x02 | 0x08 | 0x20);
			println(out, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
      println(out, "<newsfox-feed version=\"1.5\">");
      println(out, "</newsfox-feed>");
      out.close();
    }
  }
  catch (err) { alert(err); }
}

////////////////////////////////////////////////////////////////
// Save feeds to disk
////////////////////////////////////////////////////////////////

function mkBackup(file,leafName)
{
	var backupFile = getProfileDir();
	backupFile.append(leafName+".bak");
	if (backupFile.exists()) backupFile.remove(false);
	if (file.exists()) file.copyTo(getProfileDir(),leafName+".bak");
}

function saveIndices()
//  Versions   FirstNF    new_features
//      1.0       0.7      master indexes
//              0.8.1      switched to UTF-8 encoding, no actual change
{
  try
  {
    var file = getProfileDir();
		var leafName = MASTER_INDEX;
    file.append(leafName+".xml");
		mkBackup(file,leafName);

    var out = openOutputStream(file, 0x02 | 0x08 | 0x20);
		println(out, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    println(out, "<newsfox-index version=\"1.0\">");
    var fdgpidxstr = gIdx.fdgp.join();
    println(out, "  <fdgpidx>" + fdgpidxstr + "</fdgpidx>");
    var feedidxstr = gIdx.feed.join();
    println(out, "  <feedidx>" + feedidxstr + "</feedidx>");
    var catgidxstr = gIdx.catg.join();
    println(out, "  <catgidx>" + catgidxstr + "</catgidx>");
    var tmp = new Array();
    for (var i=0; i<gIdx.open.length; i++)
      tmp[i] = 1*(gIdx.open[i] == true);
    var openidxstr = tmp.join();
    println(out, "  <openidx>" + openidxstr + "</openidx>");
    println(out, "</newsfox-index>");
    out.close();
  }
  catch (err) { alert("saveIndices(): " + err); }
}

function saveGroupModel()
//  Versions   FirstNF    new_features
//      1.0       0.7      master group file
//      1.1       0.8      search groups
//      1.2     0.8.1      switched to UTF-8 encoding
//      1.3     0.8.3      searchTag, showUnread
{
  try
  {
    var file = getProfileDir();
		var leafName = MASTER_GROUP;
    file.append(leafName+".xml");
		mkBackup(file,leafName);

    var out = openOutputStream(file, 0x02 | 0x08 | 0x20);
		println(out, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    println(out, "<newsfox-grouplist version=\"1.3\">");
    for (var i=0; i<gFdGroup.length; i++)
    {
      var grpstr = gFdGroup[i].list.join();
      println(out, " <group>");
      println(out, "  <title><![CDATA[" + toUTF8(gFdGroup[i].title) + "]]></title>");
      println(out, "  <expanded>" + gFdGroup[i].expanded + "</expanded>");
      println(out, "  <search>" + gFdGroup[i].search + "</search>");
			if (gFdGroup[i].search)
			{
				if (gFdGroup[i].searchTag)
				{
					println(out, "  <searchTag>" + gFdGroup[i].searchTag + "</searchTag>");
					println(out, "  <text><![CDATA[" + toUTF8(gFdGroup[i].srchdat.text) + "]]></text>");
				}
				else
				{
					println(out, "  <showUnread>" + gFdGroup[i].showUnread + "</showUnread>");
					println(out, "  <flagged>" + gFdGroup[i].srchdat.flagged + "</flagged>");
					println(out, "  <unread>" + gFdGroup[i].srchdat.unread + "</unread>");
					println(out, "  <text><![CDATA[" + toUTF8(gFdGroup[i].srchdat.text) + "]]></text>");
					println(out, "  <textflags>" + gFdGroup[i].srchdat.textflags + "</textflags>");
					println(out, "  <startTime>" + gFdGroup[i].srchdat.startTime + "</startTime>");
					println(out, "  <endTime>" + gFdGroup[i].srchdat.endTime + "</endTime>");
				}
			}
      println(out, "  <list>" + grpstr + "</list>");
      println(out, " </group>");
    }
    println(out, "</newsfox-grouplist>");
    out.close();
  }
  catch (err) { alert("saveGroupModel(): " + err); }
}

function saveFeedModel()
//  Versions   FirstNF    new_features
//      1.0       0.2      feed_model, xml encoded
//                0.3      added homepage, style
//      1.1     0.3.4      uses CDATA
//                0.4      deleteOld
//                0.5      exclude, autoCheck, expanded
//              0.6.3      icon
//      1.2       0.7      remove expanded
//      1.3     0.8.1      switched to UTF-8 encoding, daysToKeep
//      1.4     0.8.3      tag, storage, prvate, lastUpdate, autoRefreshInterval
{
  try
  {
    var file = getProfileDir();
		var leafName = MASTER;
    file.append(leafName+".xml");
		mkBackup(file,leafName);

    var out = openOutputStream(file, 0x02 | 0x08 | 0x20);
		println(out, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    println(out, "<newsfox-feedlist version=\"1.4\">");
		println(out, " <tag><![CDATA[" + toUTF8(gTag) + "]]></tag>");
    for (var i=0; i<gFmodel.sizeTotal(); i++)
    {
      var feed = gFmodel.get(i);
      println(out, " <feed exclude=\"" + feed.exclude + "\">");
      println(out, "  <uid>" + toUTF8(feed.uid) + "</uid>");
	    println(out, "  <url><![CDATA[" + toUTF8(feed.url) + "]]></url>");
      println(out, "  <dname><![CDATA[" + toUTF8(feed.defaultName) + "]]></dname>");
			// Only save if property overrides global setting
      if (feed.style != 0)
        println(out, "  <style>" + feed.style + "</style>");
			println(out, "  <storage>" + feed.storage + "</storage>");
			if (!feed.storage)
			{
	      if (feed.homepage != null)
	        println(out, "  <home><![CDATA[" + toUTF8(feed.homepage) + "]]></home>");
	      println(out, "  <deleteOld>" + feed.deleteOld + "</deleteOld>");
	      println(out, "  <daysToKeep>" + feed.daysToKeep + "</daysToKeep>");
	      if (feed.lastUpdate) println(out, "  <lastUpdate>" + feed.lastUpdate.toUTCString() + "</lastUpdate>");
	      println(out, "  <autoRefreshInterval>" + feed.autoRefreshInterval + "</autoRefreshInterval>");
	      println(out, "  <autoCheck>" + feed.autoCheck + "</autoCheck>");
				if( null != feed.customName )
		      println(out, "  <customName><![CDATA[" + toUTF8(feed.customName) + "]]></customName>");
	      println(out, "  <dontDeleteUnread>" + feed.dontDeleteUnread + "</dontDeleteUnread>");
			}
      println(out, "  <private>" + feed.prvate + "</private>");
      print(out, "  <flags>");
			var fdflag;
      for (var j=0; j<feed.flags.length; j++)
			{
				fdflag = 1*((feed.flags[j] & 0x01)!=0) + 4*((feed.flags[j] & 0x04)!=0);
//RPdebug				if (fdflag != feed.flags[j]) alert(feed.getDisplayName() + "  j= " + j + "  feed.flags[j]= " + feed.flags[j]);
        print(out, "" + fdflag);
			}
      println(out, "</flags>");
      println(out, " </feed>");
    }
    println(out, "</newsfox-feedlist>");
    out.close();
  }
  catch (err) { alert("saveFeedModel(): [" + feed.uid + "] " + err); }
}

function saveFeed(feed)
//  Versions   FirstNF    new_features
//      1.0       0.1      also included feed_model information
//                0.2      removed feed_model, version # same, xml encoded
//      1.1     0.3.4      uses CDATA
//                0.4      category
//      1.2   0.7.5.1      deleted articles
//      1.3     0.8.1      switched to UTF-8 encoding, id, enclosures
//      1.4     0.8.2      Surl, Sname
//      1.5     0.8.3      username, password, tag
{
  var file = getProfileDir();
  file.append(feed.uid + ".xml");

  var out = openOutputStream(file, 0x02 | 0x08 | 0x20);
	var out2 = "";
	out2 += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  out2 += "<newsfox-feed version=\"1.5\">\n";
	if (feed.username  || feed.password)
	{
		out2 += " <username>" + encodeHTML(feed.username) + "</username>\n";
		out2 += " <password>" + encodeHTML(feed.password) + "</password>\n";
	}
  for (var i=0; i<feed.size(); i++)
  {
    var art = feed.get(i);
    out2 += " <article>\n";
    if (art.link) out2 += "  <link><![CDATA[" + toUTF8(art.link) + "]]></link>\n";
    out2 += "  <title><![CDATA[" + toUTF8(art.title) + "]]></title>\n";
    out2 += "  <date>" + toUTF8(art.date.toUTCString()) + "</date>\n";
    out2 += "  <body><![CDATA[" + toUTF8(art.body) + "]]></body>\n";
    // AG: added category
    out2 += "  <category><![CDATA[" + toUTF8(art.category) + "]]></category>\n";
    out2 += "  <tag><![CDATA[" + toUTF8(art.tag) + "]]></tag>\n";
		if (art.id) out2 += "  <id><![CDATA[" + toUTF8(art.id) + "]]></id>\n";
		for (var j=0; j<art.enclosures.length; j++)
		{
			var enc = art.enclosures[j];
			out2 += '  <enclosure url="' + toUTF8(encodeHTML(enc.url)) + '" type="' + toUTF8(encodeHTML(enc.type)) + '" length="' + toUTF8(encodeHTML(enc.length)) + '"/>\n';
		}
		if (art.source.url)
		{
    	out2 += "  <Surl><![CDATA[" + toUTF8(art.source.url) + "]]></Surl>\n";
    	out2 += "  <Sname><![CDATA[" + toUTF8(art.source.name) + "]]></Sname>\n";
		}
    out2 += " </article>\n";
  }
	if (!feed.storage)
	{
	  for (var i=0; i<feed.deletedsize(); i++)
	  {
	    var art = feed.deletedget(i);
	    out2 += " <deletedarticle>\n";
	    out2 += "  <link><![CDATA[" + toUTF8(art.link) + "]]></link>\n";
	    out2 += "  <date>" + toUTF8(art.date) + "</date>\n";
			out2 += "  <id><![CDATA[" + toUTF8(art.id) + "]]></id>\n";
	    out2 += " </deletedarticle>\n";
	  }
	}
  out2 += "</newsfox-feed>\n";
	if (feed.prvate)
		print(out,gSdr.encryptString(out2));
	else
		print(out,out2);
  out.close();
}

////////////////////////////////////////////////////////////////
// Delete feed
////////////////////////////////////////////////////////////////

function deleteFeedFromDisk(feed)
{
  try
  {
    var file = getProfileDir();
    file.append(feed.uid + ".xml");
    if (file.exists()) file.remove(false);
    var file = getProfileDir();
    file.append(feed.uid + ".ico");
    if (file.exists()) file.remove(false);
  }
  catch (err) {} // TODO sometimes icon file locked, file now checked on creation as well - alert("deleteFeedFromDisk(): [" + feed.uid + "] " + err); }
}

////////////////////////////////////////////////////////////////
// Util
////////////////////////////////////////////////////////////////

function child(element, tagName)
{
  var kids = element.childNodes;
  for (var i=0; i<kids.length; i++)
    if (kids[i].nodeName == tagName) 
      return kids[i];
  return null;
}

////////////////////////////////////////////////////////////////
// Encode/Decode
////////////////////////////////////////////////////////////////

/**
 * Return XML-friendly HTML encoding.
 */
function encodeHTML(s) 
{
	if (!s) return "";
  s = s.replace(new RegExp('&','gi'), '&amp;');
  s = s.replace(new RegExp('<','gi'), '&lt;');
  s = s.replace(new RegExp('>','gi'), '&gt;');
  s = s.replace(new RegExp('"','gi'), '&quot;');
  return s;
}

/**
 * Return original HTML from encoding.
 */
function decodeHTML(s)
{
  s = s.replace(new RegExp('&amp;'  ,'gi'), '&');
  s = s.replace(new RegExp('&lt;'   ,'gi'), '<');
  s = s.replace(new RegExp('&gt;'   ,'gi'), '>');
  s = s.replace(new RegExp('&quot;' ,'gi'), '"');
  s = s.replace(new RegExp('&acute;','gi'), '');
  return s;
}

function toUTF8(inVal)
{
	// CDATA(from html) tag inside CDATA(from NewsFox) tag is a problem
	try
	{
		inVal = inVal.replace(/<!\[CDATA\[(.|\n)*?]]>/g,"");
		inVal = inVal.replace(/]]>/g,"]]&gt;");
	}
	catch(e) {}
	try
	{
		var uC = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
      .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		uC.charset = "UTF-8";
		return uC.ConvertFromUnicode(inVal);
	}
	catch(e) { return inVal; }
}

// from Sage project
function entityDecode(aStr) {
 var formatConverter = Components.classes["@mozilla.org/widget/htmlformatconverter;1"].createInstance(Components.interfaces.nsIFormatConverter);
 var fromStr = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
 fromStr.data = aStr;
 var toStr = {value: null};

 try {
  formatConverter.convert("text/html", fromStr, fromStr.toString().length, "text/unicode", toStr, {});
 } catch(e) {
  return aStr;
 }
 if (toStr.value) {
  toStr = toStr.value.QueryInterface(Components.interfaces.nsISupportsString);
  return toStr.toString();
 }
 return aStr;
}
